import greenfoot.*;  // imports Actor, World, Greenfoot, GreenfootImage
import java.util.List;
import java.util.Random;

// another random number generator


/**
 * So dodging on the ground isn't that hard , right?
 * How about screw up all physics and dodge with a jet pack!!
 * 
 * @author Gafig
 * version 1.0
 */

public class BackgroundWorld extends World
{
    /**
     *set background and frame
     */
    private GreenfootImage BackGround1 = new GreenfootImage("BG1.png");
    private GreenfootImage BackGround2 = new GreenfootImage("BG2.png");
    private int BGFrame =1;
    private int CautionFrame=1;
    
    /**
     * delay and trigger for BGM
     */
    private boolean begin=true;
    private int delay=5;
    
    /**
     * timer for special events
     */
    private int timerLeft = 0;  
    private int timerRight = 0;
    private int timerUp = 0;
    private int timerSeiz = 0;
    
    private int challengeStart=500;
    
    /**
     * delay before event start
     */
    private int delay_Left=Greenfoot.getRandomNumber(1000)+challengeStart;
    private int delay_Right=Greenfoot.getRandomNumber(1000)+challengeStart;
    private int delay_Up=Greenfoot.getRandomNumber(1000)+challengeStart;
    private int delay_Seiz=Greenfoot.getRandomNumber(500);
    
    private int point=0;
    
    /**
     * define
     */
    private final int Left=1;
    private final int Right=2;
    private final int Up=3;
    private final int Seiz=4;
    
    /**
     * set BGM
     */
    GreenfootSound backgroundMusic = new GreenfootSound("BGM.mp3");
    
    
    Counter counter = new Counter("Score : ");
    /**
     * of 800x600 cells, where every cell is just 1 pixel.
     */
    public BackgroundWorld() 
    {
        super(700, 500, 1);
        setBackground("BG2.png");
        addObject(new TitleHardMode(),getWidth()/2,getHeight()/2);
        //addObject(new PlayerHardMode(),getWidth()/2,getHeight()/2);
        addObject(counter,80,40); 
    }
    
   public void act() 
    {
        if(checkStart())
        {
        if(checkGameOver())
        {
             addObject(new MiniGameOver(),getWidth()/2,getHeight()/2);
             backgroundMusic.stop();
             //Greenfoot.stop();  
        }
        if(!checkGameOver())
        {
            addSong();
            addExtraBallLeft();
            addExtraBallRight();
            addExtraBallUp();
            LevelUping();
            animate_seiz();
            counter.setValue(point/10);
            point++;
            timerLeft++;
            timerRight++;
            timerUp++;
            timerSeiz++;
            delay--;
        }
      }
        if(Greenfoot.isKeyDown("r"))
             {
                Player.bgm.playLoop();
                backgroundMusic.stop();
                Greenfoot.setWorld(new Xmeteor());
            }
    } 
    
    public void addSong()
    {
        if(begin==true)
        {
            if(delay==0)
            {
               begin=false;
               
               backgroundMusic.playLoop();
            }
            
        }
    }
    
    public void addExtraBallLeft()
    {
        
           if(timerLeft==delay_Left-100)
           caution(Left);
           else
           {
            if(timerLeft>delay_Left)
            {
                if(timerLeft%20==0)
               addObject(new ExtraBallLeft(0),4,20+Greenfoot.getRandomNumber( getHeight()-40 ));
                //addObject(new ExtraBall(0),/*getWidth()*/4,Greenfoot.getRandomNumber( getHeight() ));
               
            }
            if(timerLeft>=delay_Left+100)
            {
                timerLeft=0;
                delay_Left=Greenfoot.getRandomNumber(1000)+500;
            }
        }
    }
    
        public void addExtraBallRight()
    {
            if(timerRight==delay_Right-100)
           caution(Right);
           else
           {
            if(timerRight>delay_Right)
            {
                if(timerRight%20==0)
               addObject(new ExtraBallRight(),getWidth()-4,20+Greenfoot.getRandomNumber( getHeight()-40 ));
                
            }
            if(timerRight>=delay_Right+100)
            {
                timerRight=0;
                delay_Right=Greenfoot.getRandomNumber(1000)+500;
            }
           }
    }
    
        public void addExtraBallUp()
    {
           if(timerUp==delay_Up-100)
           caution(Up);
           else
           {
           
            if(timerUp>delay_Up)
            {
                if(timerUp%20==0)
               addObject(new ExtraBallUp(),20+Greenfoot.getRandomNumber( getWidth()-40 ),getHeight()-4);
               
            }
            if(timerUp>=100+delay_Up)
            {
                timerUp=0;
                delay_Up=Greenfoot.getRandomNumber(1000)+500;
            }
        }
    }
    
    /**
     * activate seizure time!!
     */
    public void animate_seiz() 
    {
         if(timerSeiz==delay_Seiz+2300)
           caution(Seiz);
           else
           {
        if(timerSeiz>2400+delay_Seiz)
        {
            
            if(BGFrame < 4)
            {
                setBackground(BackGround2);
                 
            }
            else if(BGFrame<8)
            {
                setBackground(BackGround1);
            }
            else
            BGFrame=0;
            BGFrame++;
        
       }
       if(timerSeiz==2700+delay_Seiz)
       {
           setBackground(BackGround2);
           timerSeiz=0;
           delay_Seiz=Greenfoot.getRandomNumber(1000);
            
       }
       }
    } 
    
    /**
     * Activate caution sign
     */
    public void caution(int CautionType)
    {
        if(CautionType==Left)
            addObject(new CautionSignLeft(),100,getHeight()/2);
        else if(CautionType==Right)
            addObject(new CautionSignRight(),getWidth()-100,getHeight()/2);
        else if(CautionType==Up)
            addObject(new CautionSignUp(),getWidth()/2,getHeight()-100);
        else if(CautionType==Seiz)
            addObject(new CautionSignSeiz(),getWidth()/2,getHeight()/2);
    }
    
    /*
     * Add more ball to world
     */
    public void LevelUping()
    {
        if(point%1000==0)
        {
           addObject(new Ball(),Greenfoot.getRandomNumber( getWidth() ),4);
           
        }
    }

    private boolean checkStart()
    {
        List Starter = getObjects(TitleHardMode.class);
        if(Starter.isEmpty())
            return true;
        else
            return false;
    }

    private boolean checkGameOver()
    {
        List player = getObjects(PlayerHardMode.class);
        if(player.isEmpty())
            return true;
        else
            return false;
    }

 
    public void addObject( Actor actor ) {
        int x = Greenfoot.getRandomNumber( getWidth() ); 
       
        addObject( actor, x, 0 );
       
        
    }
}