import greenfoot.*;  

/**
 * A star shaped item at adds 5 points to the score.
 * 
 * @author softwhizjx
 * Version 1.0
 */
public class Bonus extends Actor
{
    /** 
     * act, reappear again once collected by the player
     */
    public void act() 
    {
        int fall = 1;
        if (getY() <= 461){
            setLocation(getX(), getY()+fall);
            fall++;
        } else {
            fall = 0;
        }
        
        int randomGun = Greenfoot.getRandomNumber(10);
        int randomShield = Greenfoot.getRandomNumber(20);
        int randomBonus = Greenfoot.getRandomNumber(15);
        
        if (collide(Player.class)){
            Xmeteor world = (Xmeteor) getWorld();
            getWorld().addObject(new Bonus(), Greenfoot.getRandomNumber(getWorld().getWidth()-30)+15, 400);
            if (randomGun == 0){
                getWorld().addObject(new GunAmmo(), Greenfoot.getRandomNumber(getWorld().getWidth()-30)+15, 400);
            }
            if (randomShield == 0){
                getWorld().addObject(new ShieldItem(), Greenfoot.getRandomNumber(getWorld().getWidth()-30)+15, 400);
            }
            if (randomBonus == 0){
                getWorld().addObject(new SuperBonus(), Greenfoot.getRandomNumber(getWorld().getWidth()-30)+15, 400);
            }
            if (world.difficultyPlay == 1){
                world.addToScore(1);
            } else if (world.difficultyPlay == 2){
                world.addToScore(2);
            } else if (world.difficultyPlay == 3){
                world.addToScore(3);
            }
            Greenfoot.playSound("bonus.wav");
            getWorld().removeObject(this);
        }
        
        World world = getWorld();

        if (Greenfoot.isKeyDown("r") && world != null && GameOver.gameIsOver == true){

            world.removeObject(this);
            
        }
        
    }   
    /** 
     * Check for collisions
     */
    public boolean collide(Class hitObject){
        Actor hit = getOneIntersectingObject(hitObject);
        
        return hit != null;
    }
}
