import greenfoot.*;  

/**
 * Bullets are shot from the player when press UP.
 * It's range is limited, so it disappear a while if it didn't touch any meteor.
 * It explodes any meteor it touches, that's it's main job.
 * @auther Softwhizjx
 * Version 1.0
 */
public class Bullet extends SmoothMover
{
    /** set speed and direction value */
    private static Vector BULLET_SPEED = new Vector(-90, 8);
    
    private Xmeteor world = (Xmeteor) getWorld();
    
    /**
     * set speed and direction.
     */
    public Bullet(){
        super(BULLET_SPEED);
        
    }
    /**
     * ready to destroy any meteor it touches within it's own range.
     */
    public void act() 
    {
        moveFixedBound();
        
        
        if (this != null){
        if (collide(Meteor.class)){
            Actor victim = getOneIntersectingObject(Meteor.class);
        
                if(victim != null) {
                    Xmeteor world = (Xmeteor) getWorld();
                    Greenfoot.playSound("crush.wav");
                    if (world.difficultyPlay == 1){
                            world.addToScore(1);
                    } else if (world.difficultyPlay == 2){
                            world.addToScore(5);
                    } else if (world.difficultyPlay == 3){
                            world.addToScore(12);
                    }
                    getWorld().addObject(new Explosion(), victim.getX(), victim.getY());
                    
                    getWorld().removeObject(victim);
                    getWorld().removeObject(this);
       
                }
            //Kill Ball
            
        } else if (collide(MeteorEasy.class)){
            Actor victim = getOneIntersectingObject(MeteorEasy.class);
        
                if(victim != null) {
                    Xmeteor world = (Xmeteor) getWorld();
                    Greenfoot.playSound("crush.wav");
                    if (world.difficultyPlay == 1){
                            world.addToScore(1);
                    } else if (world.difficultyPlay == 2){
                            world.addToScore(5);
                    } else if (world.difficultyPlay == 3){
                            world.addToScore(12);
                    }
                    getWorld().addObject(new Explosion(), victim.getX(), victim.getY());
                    
                    getWorld().removeObject(victim);
                    getWorld().removeObject(this);
       
                }
            //Kill Ball
            
        } else if (collide(MeteorHard.class)){
            Actor victim = getOneIntersectingObject(MeteorHard.class);
        
                if(victim != null) {
                    Xmeteor world = (Xmeteor) getWorld();
                    Greenfoot.playSound("crush.wav");
                    if (world.difficultyPlay == 1){
                            world.addToScore(1);
                    } else if (world.difficultyPlay == 2){
                            world.addToScore(5);
                    } else if (world.difficultyPlay == 3){
                            world.addToScore(12);
                    }
                    getWorld().addObject(new Explosion(), victim.getX(), victim.getY());
                    
                    getWorld().removeObject(victim);
                    getWorld().removeObject(this);
       
                }
            //Kill Ball
            
        } 
        
            else if (getY() == 179 && this != null){
               getWorld().removeObject(this);
          }  
          
        
       }
       
       World world = getWorld();

        if (Greenfoot.isKeyDown("r") && world != null && GameOver.gameIsOver == true){

            world.removeObject(this);
            
        }
       
    }    
    /**
     * check collision.
     */
    public boolean collide(Class hitObject){
        Actor hit = getOneIntersectingObject(hitObject);
        
        return hit != null;
    }
}
