import greenfoot.*;  

import java.util.*;

/**
 * An explosion effect when the meteor is destroyed by something.
 * 
 * @author softwhizjx
 * Version 1.0
 */
public class Explosion extends Actor
{
    /** number explode effect states*/
    private final static int IMAGE_COUNT = 5;
    
    /** array of explosion images by different sizes*/
    private static GreenfootImage[] images;
    
    /** initial size for act() do the effect*/
    private int size = 0;
    
    /** initial size adjuster for act() do the effect*/
    private int increment = 1;
    /** 
     * Set the image as the first state of explosion
     */
    public Explosion(){
        initialiseImages();
        setImage(images[0]);
        
    }
    /** 
     * Set the size of each every explosion state images.
     */
    public synchronized static void initialiseImages(){
        if (images == null){
            GreenfootImage startImage = new GreenfootImage("explosion.png");
            int maxSize = startImage.getWidth();
            int delta = maxSize / (IMAGE_COUNT+1);
            int size = 0;
            images = new GreenfootImage[IMAGE_COUNT];
            for(int i = 0; i < IMAGE_COUNT; i++){
                size += delta;
                images[i] = new GreenfootImage(startImage);
                images[i].scale(size, size);
            }
        }
    }
    /** 
     * EXPLODE EFFECT
     */
    public void act() 
    {
        setImage(images[size]);
        
        size += increment;
        
        if (size == IMAGE_COUNT - 1){
            increment = -1;
        }
        //Prevents over-size
        
        if (size <= 0) {
            getWorld().removeObject(this);
        }
        
        World world = getWorld();

        if (Greenfoot.isKeyDown("r") && world != null && GameOver.gameIsOver == true){

            world.removeObject(this);
            
        }
    }     
}
