import greenfoot.*;
/**
 * This class is the playable character, one day you're unreasonably in the meteor rain,
 * SURVIVE!!!!
 * @auther Softwhizjx
 * Version 1.0
 */
public class Player extends Actor
{
    /** The world the player is playing */
    private Xmeteor play = (Xmeteor) getWorld();
    
    /** Current speed horizonally*/
    private double speed = 0;
    
    /** MAX speed horizonally */
    private double MAX_SPEED = 10;  
    
    /** for addedToWorld(World world) */
    private Xmeteor Xw;
    
    /** image variables for changing player image*/
    private GreenfootImage imageNormal = new GreenfootImage("player.png");
    private GreenfootImage imageDuck = new GreenfootImage("player_duck.png");
    
    /** Score */
    public static int score = 0;
    
    /** calls the world*/
    World world = getWorld();
    
    /**Ammunation (co-op with the Xmeteor's)*/
    static int ammo = 30;
    
    /** check "is the game playing?" */
    static boolean isGameRunning;
    
    /** game music */
    static GreenfootSound bgm = new GreenfootSound("game_music_yeah.mp3");
    
    /** 
     * canShoot at Start.
     */
    public Player(){
        score = 0;
        ammo = 30;
        GameOver.gameIsOver = false;
    }
    /** 
     * Main control, if the player hits by the meteor or not, triggers up and down key.
     */
    public void act() 
    {
       /*Controller Left and Right*/
       pressControl();
       
       Bullet Bill = new Bullet();
       
       /*move*/
       setLocation(getX() + (int)speed, getY());
       
       /*Limits the walking zone*/
       if (getX() <= 15){
           setLocation(15,getY());
        } else if (getX() >= getWorld().getWidth() - 15){
           setLocation(getWorld().getWidth() - 15,getY());
        }
       
        /*Controller Up and Down and Pause*/
        if(this != null){
        String key = Greenfoot.getKey();
        
        float x = getX();
        float y = getY();

        if (key == null){}
        else if ((key.equals("x")||key.equals("up"))&&this != null&&canShoot() == true){
            
            Greenfoot.playSound("shoot.wav");
            Xmeteor shoot = (Xmeteor) getWorld();
            shoot.subtractToAmmo(1);
            ammo--;
            getWorld().addObject(Bill, (int)x, (int)y - 20);
            
            
        } else if (key.equals("down")&&this != null){
            Greenfoot.playSound("duck.wav");
        } else if (key.equals("s")&&isGameRunning){
            bgm.stop();
            Greenfoot.playSound("pause.wav");
            getWorld().addObject(new PauseScreen(), 356, 243);
            Greenfoot.stop();
        } else if ((key.equals("enter")||key.equals("s"))&&isGameRunning==false){
            Greenfoot.playSound("resume.wav");
            Greenfoot.start();
        } else if (key.equals("r")){
            Greenfoot.playSound("reset.wav");
            Greenfoot.setWorld(new Xmeteor());
        }
      }
      /*Die once get hit*/
        if(collide(Meteor.class)){
           
           getWorld().addObject(new GameOver(), getWorld().getWidth() /2, getWorld().getHeight() /2);
           getWorld().addObject(new Died(), getX(), getY());
           getWorld().removeObject(Bill);
           getWorld().removeObject(this);
           bgm.stop();
        }
        else if(collide(MeteorEasy.class)){
           
           getWorld().addObject(new GameOver(), getWorld().getWidth() /2, getWorld().getHeight() /2);
           getWorld().addObject(new Died(), getX(), getY());
           getWorld().removeObject(Bill);
           getWorld().removeObject(this);
           bgm.stop();
        }
        else if(collide(MeteorHard.class)){
           
           getWorld().addObject(new GameOver(), getWorld().getWidth() /2, getWorld().getHeight() /2);
           getWorld().addObject(new Died(), getX(), getY());
           getWorld().removeObject(Bill);
           getWorld().removeObject(this);
           bgm.stop();
        }
        
    }  
    /** 
     * check can shoot or not.
     */
    public boolean canShoot(){
        if (ammo > 0){
            return true;
        } else {
            return false;
        }
    }
    /** 
     * refill ammo
     */
    public static void refillAmmo(int unit){
   
        ammo += unit;
     
    
    }
    
    /** 
     * Control to walk around the world.
     */
    private void pressControl(){
        if(Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("down")){
            if (speed == -MAX_SPEED){
            } else {
                speed -= 2;
            }
            
        }
        else if(Greenfoot.isKeyDown("right") && !Greenfoot.isKeyDown("down")){
            if (speed == MAX_SPEED){
            } else {
                speed += 2;
            }
            
        }
        else {
            speed = 0;
        }
        
        
        if (Greenfoot.isKeyDown("down")){
            
            setImage(imageDuck);
            setLocation(getX(),472);
            
        } else if (!Greenfoot.isKeyDown("down")){
            
            setImage(imageNormal);
            setLocation(getX(),463);
        }
        
    }
    /** 
     * Check for collisions
     */
    public boolean collide(Class hitObject){
        Actor hit = getOneIntersectingObject(hitObject);
        
        return hit != null;
    }
    
    /** 
     * let the other classes call the score value from this class
     */
     public static int getScore(){
         return score;
      }
      
    /**
     * This method is called by greenfoot each time the game is started (user presses Run)
     * Use this to do something before game starts.
     */
    public void started(){
        if (this != null){
        isGameRunning = true;
       }
    }
    /**
     * OPPOSITE
     */
    public void stopped(){
        Greenfoot.playSound("pause.wav");
        getWorld().addObject(new PauseScreen(), 356, 243);
        
        isGameRunning = false;
    }
}
