import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Title Word consists of the game's name.
 * It also generates the MeteorTitle class.
 * Disappear when press "Enter".
 * 
 * @author softwhizjx
 * Version 1.0
 */
public class Title extends Actor
{
    GreenfootSound music = new GreenfootSound("title_music.mp3"); 
    
    public Title(){
        
    }
    
    /** 
     * Generates the MeteorTitle class (background meteors) until you press enter.
     */
    public void act() 
    {
        
        if (Greenfoot.getRandomNumber(100) < 40){
            getWorld().addObject(new MeteorTitle(), Greenfoot.getRandomNumber(getWorld().getWidth()), 0);
        }
        World world = getWorld();
        if (Greenfoot.isKeyDown("enter") && world != null){
            world.removeObject(this);
            if (music.isPlaying()){
                music.stop();
              }
        }
    }    
    /**
     * This method is called by greenfoot each time the game is started (user presses Run)
     * Use this to do something before game starts.
     */
    public void started(){
        music.play();
    }
    /**
     * OPPOSITE
     */
    public void stopped(){
        music.pause();
    }
}
