import greenfoot.*;  


import java.util.Timer;
import java.lang.System;
/**
 * X-meteor is the world about the game where you have to move the playable character,
 * to move around and avoid meteors from the meteor shower as much as possible.
 * 
 * I got this idea from some kind of a lesson for gaming, floating bubbles.
 * It will be cool if the floating bubbles are in classic black and white solid colors,
 * then... it fall down, like a meteor, randomly. (From Bubbles to Meteors)
 * 
 * And it will be fun to dodge it!
 * And I love dodging obstacles deep in my bones!
 * Fun for people who love dodging survival games.
 * 
 * I purposefully made the game look simple and be what I love it to be,
 * in order for me to advance more, but slowly the better in my developing skills.
 * 
 * @auther Softwhizjx
 * Version 1.0
 * 
 * Alpha 21-25 July 2014
 */
public class Xmeteor extends World
{
    /** how tall*/
    public static final int HEIGHT = 500;
    
    /** ScoreBoard SET */
    ScoreBoard scoreboard = new ScoreBoard();
    
    /** AmmoBoard SET */
    AmmoBoard ammunation = new AmmoBoard();

    /** ScoreBoard score */
    int score = 0;
    
    /** Player's Gun Ammunation */
    int ammo = 30;

    /** Player SET */
    Player player = new Player();
    
    /** Floor SET*/
    Floor base = new Floor();
    FloorEasy baseEasy = new FloorEasy();
    FloorHard baseHard = new FloorHard();
    
    /**SET the rest*/
    Title title = new Title();
    PressEnter pressenter = new PressEnter();
    
    int difficultyPlay;

        
    
    /** 
     * Initialize game
     */
    public Xmeteor()
    {    
        
        super(700, HEIGHT, 1); 
        getBackground().setColor(Color.BLACK);
        getBackground().fill();

        addObject(new Title(), 353, 138);
        addObject(new Difficulty(), 357, 309);
        addObject(new SelectMode(), 300, 337);
        addObject(new Controls(), 74, 441);
        addObject(new Version(), 642, 485);
        
        
       

    }
    
    /**
     * This method is called by greenfoot each time the game is started (user presses Run)
     * Use this to do something before game starts.
     */
    public void started(){
        if (Player.isGameRunning == true && GameOver.gameIsOver == false){
            Player.bgm.playLoop();
        } else {
        Player.bgm.playLoop();}
    }
    /**
     * OPPOSITE
     */
    public void stopped(){
       if (Player.isGameRunning = true){
            Player.bgm.stop();
        }
    }
    /** 
     * manage stuffs in the world
     */
    public void act(){
       //String key = Greenfoot.getKey();
       //do not uncomment or else the player can't shoot or duck!!
        
        if(Greenfoot.isKeyDown("escape")){
            System.exit(1);
        }
        if (Greenfoot.isKeyDown("enter")){
         
            
        }
    }
    /**
     * Add the value of the ScoreBoard.
     */
    public void addToScore(int value){
        score += value;
        scoreboard.updateScore(score);
    }
    /**
     * Add the value of the Ammunation.
     */
    public void addToAmmo(int unit){
        ammo += unit;
        ammunation.updateAmmo(ammo);
    }
    /**
     * Subtract the value of the Ammunation.
     */
    public void subtractToAmmo(int unit){
        ammo -= unit;
        ammunation.updateAmmo(ammo);
    }
    /**
     * get the value of the current score.
     */
    public int getScore(){
        return score;
    }
    /**
     * get the value of the current ammunation.
     */
    public int getAmmo(){
        return ammo;
    }
    /**
     * Starts the game.
     */
    public void setWorld(){
        
            
        addObject(base, 350, 500);
        
        addObject(player, 350, 463);
        Player.isGameRunning = true;
        addObject(new Bonus(), Greenfoot.getRandomNumber(getWidth()-30)+15, 400);
        GameOver.gameIsOver = false;
            
        addObject(scoreboard, 99, 38);
        scoreboard.updateScore(score);
        
        addObject(ammunation, 605, 38);
        ammunation.updateAmmo(ammo);
            
        difficultyPlay = 2;
        
        Greenfoot.playSound("start.wav");
    }
    public void setWorldEasy(){
        
            
        addObject(baseEasy, 350, 500);
        
        addObject(player, 350, 463);
        Player.isGameRunning = true;
        addObject(new Bonus(), Greenfoot.getRandomNumber(getWidth()-30)+15, 400);
        GameOver.gameIsOver = false;
            
        addObject(scoreboard, 99, 38);
        scoreboard.updateScore(score);
        
        addObject(ammunation, 605, 38);
        ammunation.updateAmmo(ammo);
            
        difficultyPlay = 1;
        
        Greenfoot.playSound("start.wav");
    }
    public void setWorldHard(){
        
            
        addObject(baseHard, 350, 500);
        
        addObject(player, 350, 463);
        Player.isGameRunning = true;
        addObject(new Bonus(), Greenfoot.getRandomNumber(getWidth()-30)+15, 400);
        GameOver.gameIsOver = false;
            
        addObject(scoreboard, 99, 38);
        scoreboard.updateScore(score);
        
        addObject(ammunation, 605, 38);
        ammunation.updateAmmo(ammo);
            
        difficultyPlay = 3;
        
        Greenfoot.playSound("start.wav");
    }
    /**
     * Restarts the game.
     */
    public void resetWorld(){
        
        addObject(new Title(), 353, 138);
        addObject(new Difficulty(), 357, 309);
        addObject(new SelectMode(), 300, 337);
        addObject(new Controls(), 74, 441);
        addObject(new Version(), 642, 485);
        
    }
}
